<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php";
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';

//dynamic db
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
require_once $base_path_to_learning_resources . 'lib/task_schedule/functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';
require_once $base_path_to_learning_resources . 'lib/task_schedule/task_scheduler_functions.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;
$postdata = json_decode(file_get_contents("php://input"), true);

checkIfNoPhpContentsReceive();

if (
    !isset($postdata['institution_id']) || !checkIfIssetAndNotEmpty($postdata['institution_id']) ||
    // !isset($postdata['branch_id']) || !checkIfIssetAndNotEmpty($postdata['branch_id']) ||
    !isset($postdata['lesson_id']) || !checkIfIssetAndNotEmpty($postdata['lesson_id']) ||
    !isset($postdata['api_signature']) || !checkIfIssetAndNotEmpty($postdata['api_signature']) ||
    !isset($postdata['function_type']) || !checkIfIssetAndNotEmpty($postdata['function_type']) ||
    !isset($postdata['jwt_token']) || !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$institution_id = $postdata['institution_id'];
// $branch_id = $postdata['branch_id'];

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,['superadmin','admin'],null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'functions/common_functions.php';
require_once $base_path_to_learning . 'functions/get_branch_functions.php';

$academic_id = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
if ($academic_id == false) {
    errorreturn("Access denied. Academic session not active.");
}

if ($postdata['function_type'] == 'delete_lesson') {
    // Ensure lesson_id is provided
    if (empty($postdata['lesson_id'])) {
        errorreturn("Lesson ID is required for deletion.");
    }

    $lesson_id = $postdata['lesson_id'];

    // Check if the lesson exists based on lesson_id
    $check_lesson_sql = "SELECT id FROM lessons WHERE id = ? AND institution_id = ?";
    $stmt = $conn_rjllearning_specific->prepare($check_lesson_sql);
    $stmt->execute([$lesson_id, $institution_id]);

    $existing_lesson = $stmt->fetch(PDO::FETCH_ASSOC);

    if ($existing_lesson) {
        
        // Delete the existing lesson
        
        $lesson_delete = delete_Lesson($lesson_id, $conn_rjllearning_specific, $s3_learning_bucket, $learning_bucketName, $institution_id);
        
        manageSchedulerTask($conn_rjllearning, $workspace_id, $institution_id, 'lesson', $lesson_id, null, null, 1, $process_type = 'delete');
        
        successreturn("Successfully deleted Lesson.");
    } else {
        errorreturn("lesson ID does not exist.");
    }
}
